import { NodeProp } from "lezer-tree";
import { Style } from "style-mod";
export declare class TagSystem {
    flags: readonly string[];
    types: readonly string[];
    flagMask: number;
    typeShift: number;
    typeNames: string[];
    parents: number[];
    prop: NodeProp<number>;
    constructor(options: {
        flags: string[];
        types: string[];
    });
    get(name: string): number;
    add(tags: {
        [selector: string]: string;
    }): import("lezer-tree").NodePropSource;
    highlighter(spec: {
        [tag: string]: Style;
    }): import("../../extension/dist/extension").Extension[];
    specificity(tag: number): number;
}
export declare const defaultTags: TagSystem;
export declare const styleTags: (tags: {
    [selector: string]: string;
}) => import("lezer-tree").NodePropSource;
export declare const highlighter: (spec: {
    [tag: string]: Style;
}) => import("../../extension/dist/extension").Extension[];
export declare const defaultHighlighter: import("../../extension/dist/extension").Extension[];
