import { Text } from "../../text";
import { Extension, Configuration } from "../../extension";
import { Annotation } from "./extension";
import { EditorState } from "./state";
import { EditorSelection, SelectionRange } from "./selection";
import { Change, ChangeSet } from "./change";
export declare class Transaction {
    readonly startState: EditorState;
    changes: ChangeSet;
    docs: Text[];
    selection: EditorSelection;
    private _annotations;
    private flags;
    configuration: Configuration<EditorState>;
    private state;
    constructor(startState: EditorState, time?: number);
    readonly doc: Text;
    annotate(...annotations: Annotation<any>[]): Transaction;
    annotation<T>(type: (value: T) => Annotation<T>): T | undefined;
    annotations<T>(type: (value: T) => Annotation<T>): readonly T[];
    change(change: Change, mirror?: number): Transaction;
    readonly docChanged: boolean;
    replace(from: number, to: number, text: string | readonly string[]): Transaction;
    replaceSelection(text: string | readonly string[]): Transaction;
    forEachRange(f: (range: SelectionRange, tr: Transaction) => SelectionRange): Transaction;
    setSelection(selection: EditorSelection): Transaction;
    readonly selectionSet: boolean;
    scrollIntoView(): Transaction;
    readonly scrolledIntoView: boolean;
    replaceExtensions(replace: readonly Extension[]): this;
    reconfigure(extensions: readonly Extension[]): this;
    readonly reconfigured: boolean;
    private ensureOpen;
    apply(): EditorState;
    invertedChanges(): ChangeSet<Change>;
    static time: (value: number) => Annotation<number>;
    static preserveGoalColumn: (value: boolean) => Annotation<boolean>;
    static userEvent: (value: string) => Annotation<string>;
    static addToHistory: (value: boolean) => Annotation<boolean>;
}
