import { StringStream } from "./stringstream";
import { EditorState, Syntax, CancellablePromise } from "../../state";
import { Extension } from "../../extension";
import { Tree, NodeType, NodeProp } from "lezer-tree";
export { StringStream };
export declare type StreamParser<State> = {
    token(stream: StringStream, state: State, editorState: EditorState): string | null;
    blankLine?(state: State, editorState: EditorState): void;
    startState?(editorState: EditorState): State;
    copyState?(state: State): State;
    indent?(state: State, textAfter: string, editorState: EditorState): number;
    docProps?: readonly [NodeProp<any>, any][];
};
export declare class StreamSyntax implements Syntax {
    private field;
    extension: Extension;
    private parser;
    constructor(parser: StreamParser<any>);
    tryGetTree(state: EditorState, from: number, to: number): Tree | null;
    getTree(state: EditorState, from: number, to: number): {
        tree: Tree;
        rest: CancellablePromise<Tree> | null;
    };
    getPartialTree(state: EditorState, from: number, to: number): Tree;
    docTypeAt(state: EditorState, pos: number): NodeType;
}
